<template>
  <v-row justify="center" align="center">
    <v-col cols="12" sm="10" md="10">
      <v-card class="py-2 my-5" outlined>
        <v-card-actions class="px-5">
          <RangeDatePicker
            v-model="dates"
            lang="en"
            range></RangeDatePicker>
          <v-spacer></v-spacer>
          <v-btn
            color="primary"
            elevation="0"
            @click="search()"
          >Search
          </v-btn>
        </v-card-actions>
      </v-card>
      <v-row>
        <v-col v-for="(movie, index) in movies" :key="`movie_${index}`" cols="12" md="4">
          <v-card v-if="typeof movie.m !== 'undefined'" outlined>
            <v-row no-gutters>
              <v-col v-if="movie.m.poster_path" cols="5">
                <v-img :src="`https://image.tmdb.org/t/p/w300${movie.m.poster_path}`"></v-img>
              </v-col>
              <v-col cols="7">
                <v-card-title class="text-subtitle-2 font-weight-bold">
                  <v-btn plain text :to="`/movies/${movie.m.id}`" class="px-0" :v-ripple="false">{{ movie.title }}</v-btn>
                </v-card-title>
                <v-card-subtitle>
                  <v-icon small>mdi-calendar-range</v-icon>
                  <span>{{ movie.m.release_date }}</span>
                </v-card-subtitle>
                <v-card-text><span
v-for="(genre,i) in movie.genres" :key="`movie_${index}_genre_${i}_${genre}`"
                                   class="mr-2 font-weight-bold">{{ genre }}</span></v-card-text>
              </v-col>
            </v-row>
          </v-card>
        </v-col>
      </v-row>
      <v-container class="text-center">
        <v-row justify="center">
          <v-col cols="8">
            <v-container class="max-width">
              <v-pagination
                v-model="page"
                class="my-4"
                :length="totalPages"
                @input="changePage"
              ></v-pagination>
            </v-container>
          </v-col>
        </v-row>
      </v-container>
    </v-col>
  </v-row>
</template>

<script>
import moment from 'moment'
import {mapState} from "vuex";
import MovieService from "~/services/MovieService"

const today = moment().format("YYYY-MM-DD")
const twoYearsAgo = moment().subtract(2, 'years').format("YYYY-MM-DD")
export default {
  name: 'IndexPage',
  /* async asyncData({error}) {
    try {
      const response = await MovieService.getMovies()
      const movies = response.data.data.results
      const page = response.data.data.page
      const totalPages = response.data.data.total_pages
      const totalResults = response.data.data.total_results
      return {movies, page, totalPages, totalResults}
    } catch (e) {
      error({
        statusCode: 500,
        message: `Fetch movies error`,
      })
    }
  }, */
  data() {
    return {
      modal: false,
      dates: [twoYearsAgo, today],
      movies: [],
      page: 1,
      totalResults: 1000,
      totalPages: 10
    }
  },
  computed: {
    ...mapState({
      genres: (state) => state.genres.genres,
    }),
  },
  mounted() {
    /**
     * Fetch movies from API
     */
    this.getMovies(1)

  },
  methods: {
    changePage(page) {
      this.getMovies(page)
    },
    async getMovies(page) {
      const response = await MovieService.getMovies(page, this.dates[0], this.dates[1])
      this.movies = response.data.results
      this.page = response.data.page
      this.totalPages = response.data.total_pages <= 500 ? response.data.total_pages : 500
      this.totalResults = response.data.total_results
      this.movies = response.data.results.map((item) => {
        return {
          title: item.title.substring(0,20),
          m: item,
          genres: this.genres.filter((i) => {
            return item.genre_ids.includes(i.id)
          }).map((gnr) => {
            return gnr.name
          })
        }
      }).filter((mv) => {
        return typeof mv.m !== 'undefined'
      })
    },
    search() {
      this.getMovies(1)
    }
  }
}
</script>
<style>
.v-btn {
  text-transform: none;
}
</style>
